
_lcdWriteNibble:

;slcd.c,243 :: 		void lcdWriteNibble(unsigned char d)
;slcd.c,246 :: 		clk = 0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,247 :: 		data_= 0;
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;slcd.c,248 :: 		for(i=0;i<8;i++)
	CLRF       R1+0
L_lcdWriteNibble0:
	MOVLW      8
	SUBWF      R1+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_lcdWriteNibble1
;slcd.c,250 :: 		clk = 1;
	BSF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,251 :: 		clk = 0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,248 :: 		for(i=0;i<8;i++)
	INCF       R1+0, 1
;slcd.c,252 :: 		}
	GOTO       L_lcdWriteNibble0
L_lcdWriteNibble1:
;slcd.c,254 :: 		data_ = 1;                                        //set Q7= 1 for E
	BSF        RD0_bit+0, BitPos(RD0_bit+0)
;slcd.c,255 :: 		clk =1;
	BSF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,256 :: 		clk=0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,258 :: 		data_ = rs;                                //set Q6 for RS
	BTFSC      _rs+0, 0
	GOTO       L__lcdWriteNibble24
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
	GOTO       L__lcdWriteNibble25
L__lcdWriteNibble24:
	BSF        RD0_bit+0, BitPos(RD0_bit+0)
L__lcdWriteNibble25:
;slcd.c,259 :: 		clk =1;
	BSF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,260 :: 		clk =0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,262 :: 		for ( i=8;i>0;i=i>>1)
	MOVLW      8
	MOVWF      R1+0
L_lcdWriteNibble3:
	MOVF       R1+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L_lcdWriteNibble4
;slcd.c,264 :: 		if(d & i)
	MOVF       R1+0, 0
	ANDWF      FARG_lcdWriteNibble_d+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L_lcdWriteNibble6
;slcd.c,266 :: 		data_ =1;
	BSF        RD0_bit+0, BitPos(RD0_bit+0)
;slcd.c,267 :: 		}
	GOTO       L_lcdWriteNibble7
L_lcdWriteNibble6:
;slcd.c,270 :: 		data_ =0;
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;slcd.c,271 :: 		}
L_lcdWriteNibble7:
;slcd.c,273 :: 		clk = 1;
	BSF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,275 :: 		clk = 0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,262 :: 		for ( i=8;i>0;i=i>>1)
	RRF        R1+0, 1
	BCF        R1+0, 7
;slcd.c,276 :: 		}
	GOTO       L_lcdWriteNibble3
L_lcdWriteNibble4:
;slcd.c,278 :: 		data_=0;                        //shift Q0
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;slcd.c,279 :: 		clk = 1;
	BSF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,280 :: 		clk = 0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;slcd.c,283 :: 		data_ = 1;                //now send enable
	BSF        RD0_bit+0, BitPos(RD0_bit+0)
;slcd.c,284 :: 		data_ = 0;
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;slcd.c,285 :: 		}
L_end_lcdWriteNibble:
	RETURN
; end of _lcdWriteNibble

_lcdCmd:

;slcd.c,288 :: 		void lcdCmd(unsigned char byte)
;slcd.c,290 :: 		rs=0; //because sending command
	CLRF       _rs+0
;slcd.c,292 :: 		lcdWriteNibble(byte>>4);
	MOVF       FARG_lcdCmd_byte+0, 0
	MOVWF      FARG_lcdWriteNibble_d+0
	RRF        FARG_lcdWriteNibble_d+0, 1
	BCF        FARG_lcdWriteNibble_d+0, 7
	RRF        FARG_lcdWriteNibble_d+0, 1
	BCF        FARG_lcdWriteNibble_d+0, 7
	RRF        FARG_lcdWriteNibble_d+0, 1
	BCF        FARG_lcdWriteNibble_d+0, 7
	RRF        FARG_lcdWriteNibble_d+0, 1
	BCF        FARG_lcdWriteNibble_d+0, 7
	CALL       _lcdWriteNibble+0
;slcd.c,293 :: 		lcdWriteNibble(byte & 0x0F);
	MOVLW      15
	ANDWF      FARG_lcdCmd_byte+0, 0
	MOVWF      FARG_lcdWriteNibble_d+0
	CALL       _lcdWriteNibble+0
;slcd.c,297 :: 		}
L_end_lcdCmd:
	RETURN
; end of _lcdCmd

_lcddata_:

;slcd.c,299 :: 		void lcddata_(unsigned char byte)
;slcd.c,302 :: 		rs=1;  //because sending data_
	MOVLW      1
	MOVWF      _rs+0
;slcd.c,304 :: 		lcdWriteNibble(byte>>4);
	MOVF       FARG_lcddata__byte+0, 0
	MOVWF      FARG_lcdWriteNibble_d+0
	RRF        FARG_lcdWriteNibble_d+0, 1
	BCF        FARG_lcdWriteNibble_d+0, 7
	RRF        FARG_lcdWriteNibble_d+0, 1
	BCF        FARG_lcdWriteNibble_d+0, 7
	RRF        FARG_lcdWriteNibble_d+0, 1
	BCF        FARG_lcdWriteNibble_d+0, 7
	RRF        FARG_lcdWriteNibble_d+0, 1
	BCF        FARG_lcdWriteNibble_d+0, 7
	CALL       _lcdWriteNibble+0
;slcd.c,306 :: 		lcdWriteNibble(byte & 0x0F);
	MOVLW      15
	ANDWF      FARG_lcddata__byte+0, 0
	MOVWF      FARG_lcdWriteNibble_d+0
	CALL       _lcdWriteNibble+0
;slcd.c,309 :: 		}
L_end_lcddata_:
	RETURN
; end of _lcddata_

_lcdInit:

;slcd.c,311 :: 		void lcdInit(void)
;slcd.c,313 :: 		rs=0;
	CLRF       _rs+0
;slcd.c,314 :: 		waitLcd(40);
	MOVLW      40
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,315 :: 		lcdWriteNibble(0x03);
	MOVLW      3
	MOVWF      FARG_lcdWriteNibble_d+0
	CALL       _lcdWriteNibble+0
;slcd.c,316 :: 		waitLcd(5);
	MOVLW      5
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,317 :: 		lcdWriteNibble(0x03);
	MOVLW      3
	MOVWF      FARG_lcdWriteNibble_d+0
	CALL       _lcdWriteNibble+0
;slcd.c,318 :: 		waitLcd(5);
	MOVLW      5
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,319 :: 		lcdWriteNibble(0x03);
	MOVLW      3
	MOVWF      FARG_lcdWriteNibble_d+0
	CALL       _lcdWriteNibble+0
;slcd.c,320 :: 		waitLcd(2);
	MOVLW      2
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,321 :: 		lcdWriteNibble(0x02);
	MOVLW      2
	MOVWF      FARG_lcdWriteNibble_d+0
	CALL       _lcdWriteNibble+0
;slcd.c,323 :: 		lcdCmd(0x28);   //set data_ length 4 bit 2 line
	MOVLW      40
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,324 :: 		waitLcd(50);
	MOVLW      50
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,325 :: 		lcdCmd(0x0C);   // set display on cursor oFF blink off to on the cursor E to and on the blink F
	MOVLW      12
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,326 :: 		waitLcd(50);
	MOVLW      50
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,327 :: 		lcdCmd(0x01); // clear lcd
	MOVLW      1
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,328 :: 		waitLcd(50);
	MOVLW      50
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,329 :: 		lcdCmd(0x06);  // cursor shift direction
	MOVLW      6
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,330 :: 		waitLcd(50);
	MOVLW      50
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,331 :: 		lcdCmd(0x0C);
	MOVLW      12
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,332 :: 		waitLcd(50);
	MOVLW      50
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,333 :: 		lcdCmd(0x80);  //set ram address
	MOVLW      128
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,334 :: 		waitLcd(50);
	MOVLW      50
	MOVWF      FARG_waitLcd+0
	MOVLW      0
	MOVWF      FARG_waitLcd+1
	CALL       _waitLcd+0
;slcd.c,335 :: 		}
L_end_lcdInit:
	RETURN
; end of _lcdInit

_waitLcd:

;slcd.c,337 :: 		void waitLcd(int x)
;slcd.c,340 :: 		for (x ;x>1;x--)
L_waitLcd8:
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      FARG_waitLcd_x+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__waitLcd30
	MOVF       FARG_waitLcd_x+0, 0
	SUBLW      1
L__waitLcd30:
	BTFSC      STATUS+0, 0
	GOTO       L_waitLcd9
;slcd.c,342 :: 		for (i=0;i<=10;i++);
	CLRF       R1+0
L_waitLcd11:
	MOVF       R1+0, 0
	SUBLW      10
	BTFSS      STATUS+0, 0
	GOTO       L_waitLcd12
	INCF       R1+0, 1
	GOTO       L_waitLcd11
L_waitLcd12:
;slcd.c,340 :: 		for (x ;x>1;x--)
	MOVLW      1
	SUBWF      FARG_waitLcd_x+0, 1
	BTFSS      STATUS+0, 0
	DECF       FARG_waitLcd_x+1, 1
;slcd.c,343 :: 		}
	GOTO       L_waitLcd8
L_waitLcd9:
;slcd.c,344 :: 		}
L_end_waitLcd:
	RETURN
; end of _waitLcd

_waitUs:

;slcd.c,346 :: 		void waitUs(int x)
;slcd.c,349 :: 		for (x ;x>1;x--);
L_waitUs14:
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      FARG_waitUs_x+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__waitUs32
	MOVF       FARG_waitUs_x+0, 0
	SUBLW      1
L__waitUs32:
	BTFSC      STATUS+0, 0
	GOTO       L_waitUs15
	MOVLW      1
	SUBWF      FARG_waitUs_x+0, 1
	BTFSS      STATUS+0, 0
	DECF       FARG_waitUs_x+1, 1
	GOTO       L_waitUs14
L_waitUs15:
;slcd.c,353 :: 		}
L_end_waitUs:
	RETURN
; end of _waitUs

_gotoXy:

;slcd.c,356 :: 		void gotoXy(unsigned char  x,unsigned char y)
;slcd.c,358 :: 		if(x<40)
	MOVLW      40
	SUBWF      FARG_gotoXy_x+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_gotoXy17
;slcd.c,360 :: 		if(y) x|=0b01000000;
	MOVF       FARG_gotoXy_y+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_gotoXy18
	BSF        FARG_gotoXy_x+0, 6
L_gotoXy18:
;slcd.c,361 :: 		x|=0b10000000;
	MOVLW      128
	IORWF      FARG_gotoXy_x+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      FARG_gotoXy_x+0
;slcd.c,362 :: 		lcdCmd(x);
	MOVF       R0+0, 0
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,363 :: 		}
L_gotoXy17:
;slcd.c,364 :: 		}
L_end_gotoXy:
	RETURN
; end of _gotoXy

_prints:

;slcd.c,372 :: 		void prints(char *message){        // Write message to LCD (C string type)
;slcd.c,374 :: 		while (*message){                        // Look for end of string
L_prints19:
	MOVF       FARG_prints_message+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_prints20
;slcd.c,375 :: 		lcddata_(*message++);
	MOVF       FARG_prints_message+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_lcddata__byte+0
	CALL       _lcddata_+0
	INCF       FARG_prints_message+0, 1
;slcd.c,376 :: 		}
	GOTO       L_prints19
L_prints20:
;slcd.c,378 :: 		}
L_end_prints:
	RETURN
; end of _prints

_IntToLcd:

;slcd.c,383 :: 		void IntToLcd(int integer)   //this routine will print any int to lcd directly
;slcd.c,388 :: 		thousands = integer / 1000;
	MOVLW      232
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	MOVF       FARG_IntToLcd_integer+0, 0
	MOVWF      R0+0
	MOVF       FARG_IntToLcd_integer+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_S+0
	MOVF       R0+0, 0
	MOVWF      IntToLcd_thousands_L0+0
;slcd.c,390 :: 		lcddata_(thousands + 0x30);
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_lcddata__byte+0
	CALL       _lcddata_+0
;slcd.c,392 :: 		hundreds = ((integer - thousands*1000)-1) / 100;
	MOVF       IntToLcd_thousands_L0+0, 0
	MOVWF      R0+0
	CLRF       R0+1
	MOVLW      232
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	SUBWF      FARG_IntToLcd_integer+0, 0
	MOVWF      R0+0
	MOVF       R0+1, 0
	BTFSS      STATUS+0, 0
	ADDLW      1
	SUBWF      FARG_IntToLcd_integer+1, 0
	MOVWF      R0+1
	MOVLW      1
	SUBWF      R0+0, 1
	BTFSS      STATUS+0, 0
	DECF       R0+1, 1
	MOVLW      100
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16x16_S+0
;slcd.c,394 :: 		lcddata_( hundreds + 0x30);
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_lcddata__byte+0
	CALL       _lcddata_+0
;slcd.c,395 :: 		tens=(integer%100)/10;
	MOVLW      100
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       FARG_IntToLcd_integer+0, 0
	MOVWF      R0+0
	MOVF       FARG_IntToLcd_integer+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16x16_S+0
;slcd.c,397 :: 		lcddata_( tens + 0x30);
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_lcddata__byte+0
	CALL       _lcddata_+0
;slcd.c,398 :: 		ones=integer%10;
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       FARG_IntToLcd_integer+0, 0
	MOVWF      R0+0
	MOVF       FARG_IntToLcd_integer+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
;slcd.c,400 :: 		lcddata_( ones + 0x30);
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_lcddata__byte+0
	CALL       _lcddata_+0
;slcd.c,401 :: 		}
L_end_IntToLcd:
	RETURN
; end of _IntToLcd

_clearLcd:

;slcd.c,404 :: 		void clearLcd(void)
;slcd.c,407 :: 		lcdCmd(0x01);
	MOVLW      1
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,408 :: 		}
L_end_clearLcd:
	RETURN
; end of _clearLcd

_main:

;slcd.c,412 :: 		void main() {
;slcd.c,414 :: 		TRISD = 0x00;
	CLRF       TRISD+0
;slcd.c,415 :: 		PORTD = 0x00;
	CLRF       PORTD+0
;slcd.c,417 :: 		lcdInit();
	CALL       _lcdInit+0
;slcd.c,418 :: 		gotoXy(3,0);
	MOVLW      3
	MOVWF      FARG_gotoXy_x+0
	CLRF       FARG_gotoXy_y+0
	CALL       _gotoXy+0
;slcd.c,419 :: 		prints(&msg1);
	MOVLW      _msg1+0
	MOVWF      FARG_prints_message+0
	CALL       _prints+0
;slcd.c,420 :: 		gotoXy(3,1);
	MOVLW      3
	MOVWF      FARG_gotoXy_x+0
	MOVLW      1
	MOVWF      FARG_gotoXy_y+0
	CALL       _gotoXy+0
;slcd.c,421 :: 		prints(&msg2);
	MOVLW      _msg2+0
	MOVWF      FARG_prints_message+0
	CALL       _prints+0
;slcd.c,422 :: 		lcdCmd(0x94);
	MOVLW      148
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,423 :: 		prints(&msg3);
	MOVLW      _msg3+0
	MOVWF      FARG_prints_message+0
	CALL       _prints+0
;slcd.c,424 :: 		lcdCmd(0xD4);
	MOVLW      212
	MOVWF      FARG_lcdCmd_byte+0
	CALL       _lcdCmd+0
;slcd.c,425 :: 		prints(&msg4);
	MOVLW      _msg4+0
	MOVWF      FARG_prints_message+0
	CALL       _prints+0
;slcd.c,427 :: 		while(1){
L_main21:
;slcd.c,429 :: 		}
	GOTO       L_main21
;slcd.c,431 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
